package de.tudarmstadt.informatik.hostage.sync.wifi_direct;

import android.os.AsyncTask;


/**
 * Created by Julien on 07.01.2015.
 */
public class BackgroundTask extends AsyncTask<Void, Void, String> {

    public interface BackgroundTaskCompletionListener {
        public void didSucceed();
        public void didFail();
    }

    private boolean isInterrupted;

    public void interrupt(boolean b){
        this.isInterrupted = b;
    }

    public boolean isInterrupted() {
        return isInterrupted;
    }

    private BackgroundTaskCompletionListener completion_listener;

    public BackgroundTask(BackgroundTaskCompletionListener l){
        super();
        this.completion_listener = l;
    }

    public void setInterrupted(boolean isInterrupted) {
        this.isInterrupted = isInterrupted;
    }



    public boolean performInBackground(){
        return true;
    }

    @Override
    protected String doInBackground(Void... params) {
        boolean success = this.performInBackground();

        if (this.completion_listener != null) {
            if (success){
                this.completion_listener.didSucceed();
            }else {
                this.completion_listener.didFail();
            }
        }

        return null;
    }

    /*
     * (non-Javadoc)
     * @see android.os.AsyncTask#onPostExecute(java.lang.Object)
     */
    @Override
    protected void onPostExecute(String result) {

    }

    /*
     * (non-Javadoc)
     * @see android.os.AsyncTask#onPreExecute()
     */
    @Override
    protected void onPreExecute() {


    }

}